## herbstluftwm 0.7.0

=== CMakeLists.txt ===
# vim: set ts=4 sw=4 et:

cmake_minimum_required(VERSION 3.1)

set(CMAKE_BUILD_TYPE_INIT "Release")

cmake_policy(SET CMP0005 NEW)  # Escape preprocessor strings
cmake_policy(SET CMP0010 NEW)  # So syntax problems are errors

set(CMAKE_C_STANDARD   99)
set(CMAKE_CXX_STANDARD 11)

# redirect output
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin CACHE INTERNAL "" FORCE)
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib CACHE INTERNAL "" FORCE)

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
    message(FATAL_ERROR "In-source builds aren't supported. Remove the CMakeCache.txt and run from another directory.")
endif()

project(Herbstluftwm)


# ----------------------------------------------------------------------------
# Options

option(WITH_DOCUMENTATION "Build with documentation" ON)
option(WITH_XINERAMA "Use multi-monitor support" ON)

set(DESTDIR "" CACHE PATH "Root directory, prefix for CMAKE_INSTALL_PREFIX and CMAKE_INSTALL_SYSCONF_PREFIX when set")
set(CMAKE_INSTALL_SYSCONF_PREFIX "/etc" CACHE PATH "Directory to install configuration files")

set(SYSCONFDIR "${DESTDIR}/etc")
set(CONFIGDIR "${SYSCONFDIR}/xdg/herbstluftwm")


if(CMAKE_COMPILER_IS_GNUCC)
    set(CMAKE_C_FLAGS "-pedantic -Wall")
    set(CMAKE_CXX_FLAGS "-pedantic -Wall -Wno-sign-compare -Wno-narrowing -Wno-deprecated-register")
endif()


# ----------------------------------------------------------------------------
# Find Libraries

include(FindPkgConfig)
pkg_check_modules(GLIB2 REQUIRED glib-2.0)

if(WITH_XINERAMA)
    find_package(X11 REQUIRED)

    if(NOT X11_Xinerama_FOUND)
        set(WITH_XINERAMA OFF)
    endif()
endif()


# ----------------------------------------------------------------------------
# Find Vars

# VERSION_GIT
set(VERSION_GIT " (unknown)")
if(EXISTS ${CMAKE_SOURCE_DIR}/.git)
    find_package(Git)
    if(GIT_FOUND)
        execute_process(
            COMMAND git rev-parse --short HEAD
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE VERSION_GIT
            OUTPUT_STRIP_TRAILING_WHITESPACE
        )
        set(VERSION_GIT " (${VERSION_GIT})")
    endif()
endif()

# VERSION_* from 'version.mk'
file(STRINGS "${CMAKE_SOURCE_DIR}/version.mk" _contents REGEX "^VERSION_.*$")
string(REGEX REPLACE ".*VERSION_MAJOR[ \t]*=[ \t]*([0-9]+).*" "\\1" VERSION_MAJOR "${_contents}")
string(REGEX REPLACE ".*VERSION_MINOR[ \t]*=[ \t]*([0-9]+).*" "\\1" VERSION_MINOR "${_contents}")
string(REGEX REPLACE ".*VERSION_PATCH[ \t]*=[ \t]*([0-9]+).*" "\\1" VERSION_PATCH "${_contents}")
string(REGEX REPLACE ".*VERSION_SUFFIX[ \t]*=[ \t]*\"(.*)\".*" "\\1" VERSION_SUFFIX "${_contents}")
set(SHORTVERSION "${VERSION_MAJOR}\.${VERSION_MINOR}\.${VERSION_PATCH}${VERSION_SUFFIX}")
set(VERSION "${SHORTVERSION}${VERSION_GIT}")
unset(_contents)


# ----------------------------------------------------------------------------
# Program: 'herbstluftwm'

set(SRC
    src/clientlist.cpp              src/clientlist.h
    src/command.cpp                 src/command.h
    src/decoration.cpp              src/decoration.h
    src/desktopwindow.cpp           src/desktopwindow.h
    src/ewmh.cpp                    src/ewmh.h
    src/floating.cpp                src/floating.h
    src/glib-backports.h
    src/globals.h
    src/hook.cpp                    src/hook.h
    src/ipc-protocol.h
    src/ipc-server.cpp              src/ipc-server.h
    src/key.cpp src/key.h
    src/layout.cpp                  src/layout.h
    src/main.cpp
    src/monitor.cpp                 src/monitor.h
    src/mouse.cpp                   src/mouse.h
    src/object.cpp                  src/object.h
    src/rules.cpp                   src/rules.h
    src/settings.cpp                src/settings.h
    src/stack.cpp                   src/stack.h
    src/tag.cpp                     src/tag.h
    src/utils.cpp                   src/utils.h
    src/x11-types.h
    src/x11-utils.cpp               src/x11-utils.h
)

set(INC_SYS
    ${X11_X11_INCLUDE_PATH}
    ${GLIB2_INCLUDE_DIRS}
)

set(DEF
    -D_XOPEN_SOURCE=600
    -DHERBSTLUFT_VERSION=\"${VERSION}\"
    -DHERBSTLUFT_VERSION_MAJOR=\"${VERSION_MAJOR}\"
    -DHERBSTLUFT_VERSION_MINOR=\"${VERSION_MINOR}\"
    -DHERBSTLUFT_VERSION_PATCH=\"${VERSION_PATCH}\"
    -DHERBSTLUFT_GLOBAL_AUTOSTART="${CONFIGDIR}/autostart"
)

set(LIB
    ${X11_X11_LIB}
    # for Xshape
    ${X11_Xext_LIB}
    ${GLIB2_LIBRARIES}
)

if(WITH_XINERAMA)
    list(APPEND INC_SYS ${X11_Xinerama_INCLUDE_PATH})
    list(APPEND DEF -DXINERAMA)
    list(APPEND LIB ${X11_Xinerama_LIB})
endif()

add_executable(herbstluftwm ${SRC})

target_include_directories(herbstluftwm SYSTEM PUBLIC ${INC_SYS})
target_compile_definitions(herbstluftwm PUBLIC ${DEF})
target_link_libraries(herbstluftwm ${LIB})


# ----------------------------------------------------------------------------
# Program: 'herbstclient'

set(INC_SYS
    ${X11_X11_INCLUDE_PATH}
    ${GLIB2_INCLUDE_DIRS}
)

set(DEF
    -D_XOPEN_SOURCE=600
    -DHERBSTLUFT_VERSION=\"${VERSION}\"
    -DHERBSTLUFT_VERSION_MAJOR=\"${VERSION_MAJOR}\"
    -DHERBSTLUFT_VERSION_MINOR=\"${VERSION_MINOR}\"
    -DHERBSTLUFT_VERSION_PATCH=\"${VERSION_PATCH}\"
)

set(LIB
    ${X11_X11_LIB}
    ${GLIB2_LIBRARIES}
)

set(SRC
    ipc-client/client-utils.c       ipc-client/client-utils.h
    ipc-client/ipc-client.c         ipc-client/ipc-client.h
    ipc-client/main.c
)

add_executable(herbstclient ${SRC})

target_include_directories(herbstclient SYSTEM PUBLIC ${INC_SYS})
target_compile_definitions(herbstclient PUBLIC ${DEF})
target_link_libraries(herbstclient ${LIB})


# ----------------------------------------------------------------------------
# Install

set(BINDIR ${DESTDIR}${CMAKE_INSTALL_PREFIX}/bin)
set(DATADIR ${DESTDIR}${CMAKE_INSTALL_PREFIX}/share)
set(MANDIR ${DATADIR}/man)
set(DOCDIR ${DATADIR}/doc/herbstluftwm)
set(EXAMPLESDIR ${DOCDIR}/examples)
set(LICENSEDIR ${DOCDIR})
set(XSESSIONSDIR ${DATADIR}/xsessions)
set(ZSHCOMPLETIONDIR ${DATADIR}/zsh/functions/Completion/X)
set(BASHCOMPLETIONDIR ${SYSCONFDIR}/bash_completion.d)


install(
    TARGETS
        herbstluftwm
        herbstclient
    DESTINATION
        ${BINDIR}
)
install(
    PROGRAMS
        ${CMAKE_SOURCE_DIR}/share/dmenu_run_hlwm
    DESTINATION
        ${BINDIR}
)

install(
    FILES
        ${CMAKE_SOURCE_DIR}/BUGS
        ${CMAKE_SOURCE_DIR}/NEWS
        ${CMAKE_SOURCE_DIR}/INSTALL
    DESTINATION
        ${DOCDIR}
)

install(
    FILES
        ${CMAKE_SOURCE_DIR}/LICENSE
    DESTINATION
        ${LICENSEDIR}
)

install(
    PROGRAMS
        ${CMAKE_SOURCE_DIR}/share/autostart
        ${CMAKE_SOURCE_DIR}/share/panel.sh
        ${CMAKE_SOURCE_DIR}/share/restartpanels.sh
    DESTINATION
        ${CONFIGDIR}
)

install(
    FILES
        ${CMAKE_SOURCE_DIR}/share/herbstclient-completion
    DESTINATION
        ${BASHCOMPLETIONDIR}
)
install(
    FILES
        ${CMAKE_SOURCE_DIR}/share/_herbstclient
    DESTINATION
        ${ZSHCOMPLETIONDIR}
)
install(
    FILES
        ${CMAKE_SOURCE_DIR}/share/herbstluftwm.desktop
    DESTINATION
        ${XSESSIONSDIR}
)


install(
    FILES
        ${CMAKE_SOURCE_DIR}/scripts/README
    DESTINATION
        ${EXAMPLESDIR}
)
install(
    PROGRAMS
        ${CMAKE_SOURCE_DIR}/scripts/dmenu.sh
        ${CMAKE_SOURCE_DIR}/scripts/dumpbeautify.sh
        ${CMAKE_SOURCE_DIR}/scripts/exec_on_tag.sh
        ${CMAKE_SOURCE_DIR}/scripts/execwith.sh
        ${CMAKE_SOURCE_DIR}/scripts/floatmon.sh
        ${CMAKE_SOURCE_DIR}/scripts/herbstcommander.sh
        ${CMAKE_SOURCE_DIR}/scripts/keychain.sh
        ${CMAKE_SOURCE_DIR}/scripts/lasttag.sh
        ${CMAKE_SOURCE_DIR}/scripts/layout.sh
        ${CMAKE_SOURCE_DIR}/scripts/loadstate.sh
        ${CMAKE_SOURCE_DIR}/scripts/q3terminal.sh
        ${CMAKE_SOURCE_DIR}/scripts/savestate.sh
        ${CMAKE_SOURCE_DIR}/scripts/scratchpad.sh
        ${CMAKE_SOURCE_DIR}/scripts/wselect.sh
    DESTINATION
        ${EXAMPLESDIR}
)

if(WITH_DOCUMENTATION)
    find_program(ASCIIDOC_A2X NAMES a2x DOC "Path to AsciiDoc a2x command")
    find_program(ASCIIDOC NAMES asciidoc DOC "Path to AsciiDoc command")

    function(doc_manpage_gen sourcefile man_nr)
        set(sourcefile_target "doc_man_${sourcefile}")

        set(src_orig "${CMAKE_SOURCE_DIR}/doc/${sourcefile}.txt")
        set(src "${CMAKE_BINARY_DIR}/doc/${sourcefile}.txt")
        set(dst "${CMAKE_BINARY_DIR}/doc/${sourcefile}.${man_nr}")

        add_custom_target(${sourcefile_target} ALL DEPENDS ${dst})
        add_custom_command(
            OUTPUT ${dst}
            COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_BINARY_DIR}/doc/"
            # asciidoc doesn't support destination directory for manpages
            COMMAND ${CMAKE_COMMAND} -E copy ${src_orig} ${src}
            COMMAND ${ASCIIDOC_A2X}
                    -f manpage
                    -a \"herbstluftwmversion=herbstluftwm ${VERSION}\"
                    -a \"date=`date +%Y-%m-%d`\"
                    ${src}
            DEPENDS ${src_orig}
        )
        install(FILES ${dst} DESTINATION "${MANDIR}/man${man_nr}")
    endfunction()

    function(doc_html_gen sourcefile)
        set(sourcefile_target "doc_html_${sourcefile}")

        set(src "${CMAKE_SOURCE_DIR}/doc/${sourcefile}.txt")
        set(dst "${CMAKE_BINARY_DIR}/doc/${sourcefile}.html")

        add_custom_target(${sourcefile_target} ALL DEPENDS ${dst})
        add_custom_command(
            OUTPUT ${dst}
            COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_BINARY_DIR}/doc/"
            COMMAND ${ASCIIDOC} -o ${dst} ${src}
            DEPENDS ${src}
        )
        install(FILES ${dst} DESTINATION ${DOCDIR})
    endfunction()

    doc_manpage_gen(herbstclient 1)
    doc_manpage_gen(herbstluftwm 1)
    doc_manpage_gen(herbstluftwm-tutorial 7)

    doc_html_gen(herbstclient)
    doc_html_gen(herbstluftwm)
    doc_html_gen(herbstluftwm-tutorial)
endif()

=== Makefile ===
include version.mk
include config.mk
include colors.mk

HLWMSRC = $(wildcard src/*.cpp)
HLWMOBJ = $(HLWMSRC:.cpp=.o)
HLWMTARGET = herbstluftwm

HCSRC = $(wildcard ipc-client/*.c)
HCOBJ = $(HCSRC:.c=.o)
HCTARGET = herbstclient

TARGETS = $(HLWMTARGET) $(HCTARGET)
OBJ = $(HLWMOBJ) $(HCOBJ)
DEPS = $(OBJ:.o=.d)

HERBSTCLIENTDOC = doc/herbstclient.txt
HERBSTLUFTWMDOC = doc/herbstluftwm.txt
TUTORIAL = doc/herbstluftwm-tutorial.txt

.PHONY: depend all all-nodoc doc install install-nodoc info www
.PHONY: cleandoc cleanwww cleandeps clean

all: $(TARGETS) doc
all-nodoc: $(TARGETS)

$(HCTARGET): $(HCOBJ)
	$(call colorecho,LD,$@)
	$(VERBOSE) $(LD) -o $@ $(CFLAGS) $(LDFLAGS) $^ $(LIBS)

$(HLWMTARGET): $(HLWMOBJ)
	 $(LDXX) -o $@ $(CXXFLAGS) $(LDXXFLAGS) $^ $(LIBS)

-include $(DEPS)

%.o: %.c version.mk
	$(call colorecho,CC,$<)
	$(VERBOSE) $(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<
	$(VERBOSE) $(CC) -c $(CPPFLAGS) -o $*.d -MT $@ -MM $<

%.o: %.cpp version.mk
	$(call colorecho,CXX,$<)
	$(VERBOSE) $(CXX) -c $(CPPFLAGS) $(CXXFLAGS) -o $@ $<
	$(VERBOSE) $(CXX) -c $(CPPFLAGS) $(CXXFLAGS) -o $*.d -MT $@ -MM $<


info:
	@echo Some Info:
	@echo Preprocessing with: $(CC) -E $(CPPFLAGS)
	@echo Compiling C with: $(CC) -c $(CPPFLAGS) $(CFLAGS) -o OUT INPUT
	@echo Compiling C++ with: $(CXX) -c $(CPPFLAGS) $(CXXFLAGS) -o OUT INPUT
	@echo Linking with: $(LD) -o OUT $(LDFLAGS) INPUT

clean: cleandoc cleandeps
	$(call colorecho,RM,$(TARGETS))
	$(VERBOSE) rm -f $(TARGETS)
	$(call colorecho,RM,$(OBJ))
	$(VERBOSE) rm -f $(OBJ)

cleandeps:
	$(call colorecho,RM,$(DEPS))
	$(VERBOSE) rm -f $(DEPS)

cleandoc:
	$(call colorecho,RM,doc/herbstclient.1)
	$(VERBOSE) rm -f doc/herbstclient.1
	$(call colorecho,RM,doc/herbstclient.html)
	$(VERBOSE) rm -f doc/herbstclient.html
	$(call colorecho,RM,doc/herbstluftwm.1)
	$(VERBOSE) rm -f doc/herbstluftwm.1
	$(call colorecho,RM,doc/herbstluftwm.html)
	$(VERBOSE) rm -f doc/herbstluftwm.html
	$(call colorecho,RM,doc/herbstluftwm-tutorial.7)
	$(VERBOSE) rm -f doc/herbstluftwm-tutorial.7
	$(call colorecho,RM,doc/herbstluftwm-tutorial.html)
	$(VERBOSE) rm -f doc/herbstluftwm-tutorial.html

doc: doc/herbstclient.1    \
     doc/herbstclient.html \
     doc/herbstluftwm.1    \
     doc/herbstluftwm.html \
     doc/herbstluftwm-tutorial.7    \
     doc/herbstluftwm-tutorial.html

tar: doc
	tar -czf $(TARFILE) `git ls-files` doc/*.html doc/*.[0-9]
	rm -rf $(TMPTARDIR)
	mkdir -p $(TMPTARDIR)
	tar -xvf $(TARFILE) -C $(TMPTARDIR)
	tar -czf $(TARFILE) $(TMPTARDIR)
	rm -rf $(TMPTARDIR)
	gpg --detach-sign $(TARFILE)

doc/%.1 doc/%.7: doc/%.txt version.mk
	$(call colorecho,DOC,$@)
	$(VERBOSE) $(A2X) -f manpage -a "herbstluftwmversion=herbstluftwm $(VERSION)" -a "date=`date +%Y-%m-%d`" $<

doc/%.html: doc/%.txt version.mk
	$(call colorecho,DOC,$@)
	$(VERBOSE) $(ASCIIDOC) $<

install: all install-nodoc
	@echo "==> creating dirs..."
	$(MKDIR) '$(DESTDIR)$(MAN1DIR)'
	$(MKDIR) '$(DESTDIR)$(MAN7DIR)'
	$(MKDIR) '$(DESTDIR)$(DOCDIR)'
	@echo "==> copying files..."
	$(INSTALL) -m 644 doc/herbstclient.1 '$(DESTDIR)$(MAN1DIR)/'
	$(INSTALL) -m 644 doc/herbstluftwm.1 '$(DESTDIR)$(MAN1DIR)/'
	$(INSTALL) -m 644 doc/herbstluftwm-tutorial.7 '$(DESTDIR)$(MAN7DIR)/'
	$(INSTALL) -m 644 doc/herbstclient.html '$(DESTDIR)$(DOCDIR)/'
	$(INSTALL) -m 644 doc/herbstluftwm.html '$(DESTDIR)$(DOCDIR)/'
	$(INSTALL) -m 644 doc/herbstluftwm-tutorial.html '$(DESTDIR)$(DOCDIR)/'

install-nodoc: all-nodoc
	@echo "==> creating dirs..."
	$(MKDIR) '$(DESTDIR)$(LICENSEDIR)'
	$(MKDIR) '$(DESTDIR)$(BINDIR)'
	$(MKDIR) '$(DESTDIR)$(DOCDIR)'
	$(MKDIR) '$(DESTDIR)$(EXAMPLESDIR)'
	$(MKDIR) '$(DESTDIR)$(BASHCOMPLETIONDIR)'
	$(MKDIR) '$(DESTDIR)$(CONFIGDIR)'
	$(MKDIR) '$(DESTDIR)$(ZSHCOMPLETIONDIR)'
	$(MKDIR) '$(DESTDIR)$(XSESSIONSDIR)'
	@echo "==> copying files..."
	$(INSTALL) $(TARGETS) '$(DESTDIR)$(BINDIR)/'
	$(INSTALL) -m 644 LICENSE '$(DESTDIR)$(LICENSEDIR)/'
	$(INSTALL) -m 644 BUGS '$(DESTDIR)$(DOCDIR)/'
	$(INSTALL) -m 644 NEWS '$(DESTDIR)$(DOCDIR)/'
	$(INSTALL) -m 644 INSTALL '$(DESTDIR)$(DOCDIR)/'
	$(INSTALL) -m 755 share/autostart '$(DESTDIR)$(CONFIGDIR)/'
	$(INSTALL) -m 755 share/panel.sh '$(DESTDIR)$(CONFIGDIR)/'
	$(INSTALL) -m 755 share/restartpanels.sh '$(DESTDIR)$(CONFIGDIR)/'
	$(INSTALL) -m 644 share/herbstclient-completion '$(DESTDIR)$(BASHCOMPLETIONDIR)/'
	$(INSTALL) -m 644 share/_herbstclient '$(DESTDIR)$(ZSHCOMPLETIONDIR)/'
	$(INSTALL) -m 644 share/herbstluftwm.desktop '$(DESTDIR)$(XSESSIONSDIR)/'
	$(INSTALL) -m 755 share/dmenu_run_hlwm '$(DESTDIR)$(BINDIR)/'
	$(INSTALL) -m 644 scripts/README '$(DESTDIR)$(EXAMPLESDIR)/'
	$(INSTALL) -m 755 scripts/*.sh '$(DESTDIR)$(EXAMPLESDIR)/'



uninstall:
	@echo "==> deleting files..."
	-$(foreach TARGET,$(TARGETS),$(RM) '$(DESTDIR)$(BINDIR)/$(TARGET)';)
	-$(RM) '$(DESTDIR)$(BINDIR)/dmenu_run_hlwm'
	-$(RM) '$(DESTDIR)$(LICENSEDIR)/LICENSE'
	-$(RM) '$(DESTDIR)$(MAN1DIR)/herbstclient.1'
	-$(RM) '$(DESTDIR)$(MAN1DIR)/herbstluftwm.1'
	-$(RM) '$(DESTDIR)$(MAN7DIR)/herbstluftwm-tutorial.7'
	-$(RM) '$(DESTDIR)$(DOCDIR)/herbstclient.html'
	-$(RM) '$(DESTDIR)$(DOCDIR)/herbstluftwm.html'
	-$(RM) '$(DESTDIR)$(DOCDIR)/herbstluftwm-tutorial.html'
	-$(RM) '$(DESTDIR)$(DOCDIR)/BUGS'
	-$(RM) '$(DESTDIR)$(DOCDIR)/NEWS'
	-$(RM) '$(DESTDIR)$(DOCDIR)/INSTALL'
	-$(RM) '$(DESTDIR)$(CONFIGDIR)/autostart'
	-$(RM) '$(DESTDIR)$(CONFIGDIR)/panel.sh'
	-$(RM) '$(DESTDIR)$(CONFIGDIR)/restartpanels.sh'
	-$(RM) '$(DESTDIR)$(BASHCOMPLETIONDIR)/herbstclient-completion'
	-$(RM) '$(DESTDIR)$(ZSHCOMPLETIONDIR)/_herbstclient'
	-$(RM) '$(DESTDIR)$(XSESSIONSDIR)/herbstluftwm.desktop'
	-$(RM) '$(DESTDIR)$(EXAMPLESDIR)/README'
	-$(RM) '$(DESTDIR)$(EXAMPLESDIR)'/*.sh
	@echo "==> deleting directories..."
	-$(RMDIR) '$(DESTDIR)$(EXAMPLESDIR)/'
	-$(RMDIR) '$(DESTDIR)$(DOCDIR)/'
	-$(RMDIR) '$(DESTDIR)$(CONFIGDIR)/'

www:
	make -C www

cleanwww:
	make -C www clean

=== www/Makefile ===

include ../version.mk
include ../config.mk
include ../colors.mk

.PHONY: all clean install

TARGET = herbstluftwm.org:www/

ASCIIDOCFLAGS = -s
TXT = $(wildcard *.txt)
INSTALLFILES = $(TXT:.txt=.html) \
	herbstluftwm.html \
	herbstclient.html \
	herbstluftwm.svg \
	main.css

all: $(INSTALLFILES)

%-content.html: %.txt
	$(call colorecho,DOC,$@)
	$(ASCIIDOC) $(ASCIIDOCFLAGS) -o $@ $<

%.html: %-content.html compose.py
	./compose.py $< > $@

herbstluftwm.svg: ../share/herbstluftwm.svg
	cp $^ $@

news.html: ../NEWS

migration.html: ../MIGRATION

herbstluftwm.html: ../doc/herbstluftwm.txt

herbstclient.html: ../doc/herbstclient.txt

tutorial.html: ../doc/herbstluftwm-tutorial.txt

faq-toc.html: faq-content.html ./gentoc.sh
	./gentoc.sh $< > $@

faq.html: faq-toc.html

clean:
	rm -f *.html *-content.html

install: all
	rsync -v $(INSTALLFILES) $(TARGET)

=== debian/changelog ===
herbstluftwm (0.7.0-2) unstable; urgency=medium

  * Import patch by Fabian Wolff to make build reproducible (Closes:
    #823961)
  * Add xfonts-base to Recommends as suggested by Sebastian Hahn
    (Closes: #817143)
  * Update URLs
  * Bump standards version to 4.1.0
  * Move completions to vendor directory (Closes: ##843573)

 -- Christoph Egger <christoph@debian.org>  Sun, 01 Oct 2017 17:06:43 +0200

herbstluftwm (0.7.0-1) unstable; urgency=medium

  * New upstream release
  * Add GPG key to uscan mechanism
  * Enable hardening
  * install bash completion to /usr/share
  * enable parallel build
  * Do not install redundant INSTALL file

 -- Christoph Egger <christoph@debian.org>  Mon, 08 Feb 2016 22:31:16 +0100

=== debian/control ===
Source: herbstluftwm
Section: x11
Priority: optional
Maintainer: Christoph Egger <christoph@debian.org>
Build-Depends:
 debhelper (>= 9~),
 libglib2.0-dev,
 libx11-dev,
 libxinerama-dev,
 asciidoc,
 libxml2-utils,
 docbook-xml,
 docbook-xsl,
 xsltproc
Standards-Version: 4.1.0
Homepage: https://herbstluftwm.org
Vcs-Git: https://anonscm.debian.org/git/collab-maint/herbstluftwm.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/herbstluftwm.git;a=summary

Package: herbstluftwm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: dzen2, xterm, xfonts-base
Suggests: suckless-tools
Provides: x-window-manager
Description: manual tiling window manager for X11
 In herbstluftwm the layout is based on splitting frames into
 subframes which can be split again or can be filled with windows,
 Tags (or workspaces or virtual desktops or ...) can be added/removed
 at runtime. Each tag contains an own layout and exactly one tag is
 viewed on each monitor. The tags are monitor independent.
 .
 It is configured at runtime via ipc calls from herbstclient. So the
 configuration file is just a script which is run on startup.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel

override_dh_auto_clean:
	dh_auto_clean -- VERBOSE= COLOR=0

override_dh_auto_build:
	dh_auto_build -- VERBOSE= COLOR=0 LDXXFLAGS="$(LDFLAGS)"

override_dh_auto_install:
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/herbstluftwm/ BASHCOMPLETIONDIR=/usr/share/bash-completion/completions ZSHCOMPLETIONDIR=/usr/share/zsh/vendor-completions install
	rm -rf $(CURDIR)/debian/herbstluftwm/usr/share/licenses \
	       $(CURDIR)/debian/herbstluftwm/usr/share/doc/herbstluftwm/LICENSE \
	       $(CURDIR)/debian/herbstluftwm/usr/share/doc/herbstluftwm/INSTALL

override_dh_installwm:
	dh_installwm --priority=20 herbstluftwm

=== debian/watch ===
version=3

opts=pgpsigurlmangle=s/$/.sig/ \
http://herbstluftwm.org/tarballs/herbstluftwm-([\d.]+).tar.gz

## herbstluftwm 0.7.1

=== debian/changelog ===
herbstluftwm (0.7.1-2) unstable; urgency=medium

  * reenable reproducibility

 -- Christoph Egger <christoph@debian.org>  Tue, 21 Aug 2018 22:35:15 +0200

herbstluftwm (0.7.1-1) unstable; urgency=medium

  * New upstream release
  * Move to salsa's Debian group from collab-maint

 -- Christoph Egger <christoph@debian.org>  Sat, 18 Aug 2018 18:26:34 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Christoph Egger <christoph@debian.org>
 Build-Depends:
- debhelper (>= 9~),
+ debhelper (>= 11~),
  libglib2.0-dev,
  libx11-dev,
  libxinerama-dev,
@@ -12,10 +12,10 @@
  docbook-xml,
  docbook-xsl,
  xsltproc
-Standards-Version: 4.1.0
+Standards-Version: 4.1.4
 Homepage: https://herbstluftwm.org
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/herbstluftwm.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/herbstluftwm.git;a=summary
+Vcs-Git: https://salsa.debian.org/debian/herbstluftwm.git
+Vcs-Browser: https://salsa.debian.org/debian/herbstluftwm
 
 Package: herbstluftwm
 Architecture: any

## herbstluftwm 0.7.2

=== Makefile ===
--- 
+++ 
@@ -121,6 +121,7 @@
 	$(MKDIR) '$(DESTDIR)$(BASHCOMPLETIONDIR)'
 	$(MKDIR) '$(DESTDIR)$(CONFIGDIR)'
 	$(MKDIR) '$(DESTDIR)$(ZSHCOMPLETIONDIR)'
+	$(MKDIR) '$(DESTDIR)$(FISHCOMPLETIONDIR)'
 	$(MKDIR) '$(DESTDIR)$(XSESSIONSDIR)'
 	@echo "==> copying files..."
 	$(INSTALL) $(TARGETS) '$(DESTDIR)$(BINDIR)/'
@@ -132,6 +133,7 @@
 	$(INSTALL) -m 755 share/panel.sh '$(DESTDIR)$(CONFIGDIR)/'
 	$(INSTALL) -m 755 share/restartpanels.sh '$(DESTDIR)$(CONFIGDIR)/'
 	$(INSTALL) -m 644 share/herbstclient-completion '$(DESTDIR)$(BASHCOMPLETIONDIR)/'
+	$(INSTALL) -m 644 share/herbstclient.fish '$(DESTDIR)$(FISHCOMPLETIONDIR)/'
 	$(INSTALL) -m 644 share/_herbstclient '$(DESTDIR)$(ZSHCOMPLETIONDIR)/'
 	$(INSTALL) -m 644 share/herbstluftwm.desktop '$(DESTDIR)$(XSESSIONSDIR)/'
 	$(INSTALL) -m 755 share/dmenu_run_hlwm '$(DESTDIR)$(BINDIR)/'
@@ -158,6 +160,7 @@
 	-$(RM) '$(DESTDIR)$(CONFIGDIR)/panel.sh'
 	-$(RM) '$(DESTDIR)$(CONFIGDIR)/restartpanels.sh'
 	-$(RM) '$(DESTDIR)$(BASHCOMPLETIONDIR)/herbstclient-completion'
+	-$(RM) '$(DESTDIR)$(FISHCOMPLETIONDIR)/herbstclient.fish'
 	-$(RM) '$(DESTDIR)$(ZSHCOMPLETIONDIR)/_herbstclient'
 	-$(RM) '$(DESTDIR)$(XSESSIONSDIR)/herbstluftwm.desktop'
 	-$(RM) '$(DESTDIR)$(EXAMPLESDIR)/README'

=== debian/changelog ===
herbstluftwm (0.7.2-3build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:43:39 +0100

herbstluftwm (0.7.2-3) unstable; urgency=medium

  * Reproducibility fixes

 -- Christoph Egger <christoph@debian.org>  Mon, 14 Oct 2019 00:38:12 +0200

herbstluftwm (0.7.2-2) unstable; urgency=medium

  * Upload to unstable

 -- Christoph Egger <christoph@debian.org>  Sun, 13 Oct 2019 16:14:33 +0200

herbstluftwm (0.7.2-1) experimental; urgency=medium

  * New upstream release

 -- Christoph Egger <christoph@debian.org>  Thu, 06 Jun 2019 22:29:32 +0200

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_clean:
 	dh_auto_clean -- VERBOSE= COLOR=0

## herbstluftwm 0.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1...3.13)

file(STRINGS VERSION VERSION) # read hlwm version from file 'VERSION'
project(Herbstluftwm
    VERSION ${VERSION})

# use our cmake dir for include(…) statements
list(INSERT CMAKE_MODULE_PATH 0 "${PROJECT_SOURCE_DIR}/cmake")

# make CMake behave our way
include(behavior)
# get project dependencies
include(dependencies)
# generate variable PROJECT_VERSION_GIT, provide function export_version()
include(gitversion)
# add custom (default) debug flags in variable cache
include(debugflags)
# find ccache (offered via ENABLE_CCACHE if available)
include(ccache)

## set install variables
# prefix for systemwide configuration, accompanies CMAKE_INSTALL_PREFIX
set(CMAKE_INSTALL_SYSCONF_PREFIX "/etc" CACHE PATH
    "Top-level install path for configuration files. May be given relative to CMAKE_INSTALL_PREFIX.")

set(CONFIGDIR "${CMAKE_INSTALL_SYSCONF_PREFIX}/xdg/herbstluftwm")
set(BINDIR bin)
set(DATADIR share)
set(MANDIR ${DATADIR}/man)
set(DOCDIR ${DATADIR}/doc/herbstluftwm)
set(LICENSEDIR ${DOCDIR}
    CACHE PATH "Install path for license file")
set(XSESSIONSDIR ${DATADIR}/xsessions
    CACHE PATH "Install path for xsession file")
set(ZSHCOMPLETIONDIR ${DATADIR}/zsh/site-functions
    CACHE PATH "Install path for zsh completions file")
set(FISHCOMPLETIONDIR ${DATADIR}/fish/vendor_completions.d
    CACHE PATH "Install path for fish completions file")
set(BASHCOMPLETIONDIR ${CMAKE_INSTALL_SYSCONF_PREFIX}/bash_completion.d
    CACHE PATH "Install path for bash completions file")

## do the actual work
add_subdirectory(ipc-client)
add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(share)

## install everything that was not installed from subdirectories
install(FILES BUGS NEWS INSTALL DESTINATION ${DOCDIR})
install(FILES LICENSE DESTINATION ${LICENSEDIR})
install(DIRECTORY scripts/ DESTINATION ${DOCDIR}/examples USE_SOURCE_PERMISSIONS)

# vim: et:ts=4:sw=4

=== doc/CMakeLists.txt ===
option(WITH_DOCUMENTATION "Build with documentation" ON)

function(gen_manpage sourcefile man_nr)
    set(src_orig "${CMAKE_CURRENT_SOURCE_DIR}/${sourcefile}.txt")
    set(src "${CMAKE_CURRENT_BINARY_DIR}/${sourcefile}.txt")
    set(dst "${CMAKE_CURRENT_BINARY_DIR}/${sourcefile}.${man_nr}")

    add_custom_target("doc_man_${sourcefile}" ALL DEPENDS ${dst})
    add_custom_command(
        OUTPUT ${dst}
        COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}"
        # asciidoc doesn't support destination directory for manpages
        COMMAND ${CMAKE_COMMAND} -E copy ${src_orig} ${src}
        COMMAND ${ASCIIDOC_A2X}
                -f manpage
                -a \"herbstluftwmversion=herbstluftwm ${VERSION}\"
                -a \"date=`date +%Y-%m-%d`\"
                ${src}
        DEPENDS ${src_orig}
        )
    install(FILES ${dst} DESTINATION "${MANDIR}/man${man_nr}")
endfunction()

function(gen_html sourcefile)
    set(src "${CMAKE_CURRENT_SOURCE_DIR}/${sourcefile}.txt")
    set(dst "${CMAKE_CURRENT_BINARY_DIR}/${sourcefile}.html")

    add_custom_target("doc_html_${sourcefile}" ALL DEPENDS ${dst})
    add_custom_command(
        OUTPUT ${dst}
        COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}"
        COMMAND ${ASCIIDOC} -o ${dst} ${src}
        DEPENDS ${src}
        )
    install(FILES ${dst} DESTINATION ${DOCDIR})
endfunction()

if (WITH_DOCUMENTATION)
    find_program(ASCIIDOC_A2X NAMES a2x DOC "Path to AsciiDoc a2x command")
    find_program(ASCIIDOC NAMES asciidoc DOC "Path to AsciiDoc command")

    gen_manpage(herbstclient 1)
    gen_manpage(herbstluftwm 1)
    gen_manpage(herbstluftwm-tutorial 7)

    gen_html(herbstclient)
    gen_html(herbstluftwm)
    gen_html(herbstluftwm-tutorial)
endif()

# vim: et:ts=4:sw=4

=== share/CMakeLists.txt ===
add_custom_target("copy_autostart" ALL)
add_custom_command(
    TARGET copy_autostart POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy
    ${CMAKE_CURRENT_SOURCE_DIR}/autostart
    ${CMAKE_CURRENT_BINARY_DIR}/autostart)

install(FILES herbstclient-completion DESTINATION ${BASHCOMPLETIONDIR})
install(FILES _herbstclient           DESTINATION ${ZSHCOMPLETIONDIR})
install(FILES herbstclient.fish       DESTINATION ${FISHCOMPLETIONDIR})
install(FILES herbstluftwm.desktop    DESTINATION ${XSESSIONSDIR})

install(PROGRAMS
    autostart
    panel.sh
    restartpanels.sh
    dmenu_run_hlwm
    DESTINATION ${CONFIGDIR}
)

# vim: et:ts=4:sw=4

=== debian/changelog ===
herbstluftwm (0.8.0-2.0antix1) unstable; urgency=medium

  * antiX buster build 

 -- anticapitalista <antix@operamail.com>  Sat, 11 Apr 2020 23:17:43 +0300

herbstluftwm (0.8.0-2) unstable; urgency=medium

  * Import upstream patches to fix 32-bit builds
  * Fix build reproducibility

 -- Christoph Egger <christoph@debian.org>  Fri, 10 Apr 2020 12:48:21 +0200

herbstluftwm (0.8.0-1) unstable; urgency=medium

  * New upstream release

 -- Christoph Egger <christoph@debian.org>  Fri, 10 Apr 2020 00:51:20 +0200

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export BUILD_DATE = $(shell dpkg-parsechangelog -SDate | date -f- +"%Y-%m-%d")
PYTEST_VERSION = $(shell python3 -c 'import sys ; print("py" + "".join([str(i) for i in sys.version_info[:2]]))')

%:
	dh $@ --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install --buildsystem=cmake
	rm -f $(CURDIR)/debian/herbstluftwm/usr/share/doc/herbstluftwm/INSTALL
	mv $(CURDIR)/debian/herbstluftwm/etc/bash_completion.d/herbstclient-completion \
	   $(CURDIR)/debian/herbstluftwm/usr/share/bash-completion/completions/herbstclient-completion
	-rmdir $(CURDIR)/debian/herbstluftwm/etc/bash_completion.d

#override_dh_auto_test:
#	(cd obj-* ; tox -c .. -e py3)


override_dh_installwm:
	dh_installwm --priority=20 herbstluftwm

## herbstluftwm 0.8.1

=== src/CMakeLists.txt ===
## The 'herbstluftwm' executable ##

add_executable(herbstluftwm main.cpp)
install(TARGETS herbstluftwm DESTINATION ${BINDIR})

# additional sources – core/architectural stuff
target_sources(herbstluftwm PRIVATE
    arglist.cpp arglist.h
    attribute.cpp attribute.h attribute_.h
    byname.cpp byname.h
    child.h
    client.cpp client.h
    clientmanager.cpp clientmanager.h
    command.cpp command.h
    completion.h
    completion.h completion.cpp
    decoration.cpp decoration.h
    desktopwindow.h desktopwindow.cpp
    entity.cpp entity.h
    ewmh.cpp ewmh.h
    floating.cpp floating.h
    framedata.h framedata.cpp
    framedecoration.cpp framedecoration.h
    frameparser.h frameparser.cpp
    frametree.h frametree.cpp
    globals.h
    hlwmcommon.cpp hlwmcommon.h
    hook.cpp hook.h
    hookmanager.cpp hookmanager.h
    indexingobject.h
    ipc-protocol.h
    ipc-server.cpp ipc-server.h
    keycombo.cpp keycombo.h
    keymanager.cpp keymanager.h
    layout.cpp layout.h
    link.h
    monitor.cpp monitor.h
    monitordetection.cpp monitordetection.h
    monitormanager.cpp monitormanager.h
    mouse.cpp mouse.h
    mousemanager.cpp mousemanager.h
    mousedraghandler.cpp mousedraghandler.h
    namedhook.cpp namedhook.h
    object.cpp object.h
    optional.h
    plainstack.h
    panelmanager.h panelmanager.cpp
    rectangle.cpp rectangle.h
    regexstr.cpp regexstr.h
    rootcommands.cpp rootcommands.h
    root.cpp root.h
    rulemanager.cpp rulemanager.h
    rules.cpp rules.h
    settings.cpp settings.h
    signal.h
    stack.cpp stack.h
    tag.cpp tag.h
    tagmanager.cpp tagmanager.h
    theme.cpp theme.h
    tilingresult.cpp tilingresult.h
    tmp.cpp tmp.h
    types.cpp types.h
    utils.cpp utils.h
    x11-types.cpp x11-types.h
    x11-utils.cpp x11-utils.h
    xconnection.cpp xconnection.h
    xkeygrabber.cpp xkeygrabber.h
    xmainloop.cpp xmainloop.h
    )

# we require C++11
set_target_properties(herbstluftwm PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON)

## options
include(CMakeDependentOption)
cmake_dependent_option(WITH_XINERAMA "Use multi-monitor support via xinerama" ON
    "X11_Xinerama_FOUND" OFF)

if (WITH_XINERAMA)
    set_property(SOURCE monitordetection.cpp APPEND PROPERTY COMPILE_DEFINITIONS XINERAMA)
    target_link_libraries(herbstluftwm PRIVATE ${X11_Xinerama_LIB})
endif()

## dependencies X11 (link to Xext for XShape())
target_include_directories(herbstluftwm SYSTEM PUBLIC
    ${X11_X11_INCLUDE_PATH} ${X11_Xinerama_INCLUDE_PATH} ${X11_Xrandr_INCLUDE_PATH})
target_link_libraries(herbstluftwm PUBLIC
    ${X11_X11_LIB} ${X11_Xext_LIB} ${X11_Xrandr_LIB})

## export variables to the code
# version string
export_version(main.cpp)
# systemwide autostart location
set_property(SOURCE main.cpp APPEND PROPERTY COMPILE_DEFINITIONS
    HERBSTLUFT_GLOBAL_AUTOSTART=\"${CONFIGDIR}/autostart\")

# vim: et:ts=4:sw=4

=== debian/changelog ===
herbstluftwm (0.8.1-1~mx17+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 26 Apr 2020 11:27:15 -0700

herbstluftwm (0.8.1-1) unstable; urgency=medium

  * Fix reproducible build (Closes: #956477), thanks to Chris Lamb
  * New upstream version
    * bash_completion now installed where we would like it so remove renaming code

 -- Christoph Egger <christoph@debian.org>  Wed, 22 Apr 2020 20:41:52 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,28 @@
 Source: herbstluftwm
 Section: x11
 Priority: optional
-Maintainer: Christoph Egger <christoph@debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Christoph Egger <christoph@debian.org>
 Build-Depends:
- debhelper (>= 11~),
- libglib2.0-dev,
+ asciidoc,
+ cmake,
+ debhelper (>= 12~),
+ docbook-xml,
+ docbook-xsl,
  libx11-dev,
  libxinerama-dev,
- asciidoc,
  libxml2-utils,
- docbook-xml,
- docbook-xsl,
- xsltproc
+ libxrandr-dev,
+# python3,
+# python3-ewmh,
+# python3-pytest,
+# python3-pytest-xdist,
+# python3-pytest-xvfb,
+# python3-xlib,
+# tox,
+ xsltproc,
+# x11-utils,
+# xterm
 Standards-Version: 4.1.4
 Homepage: https://herbstluftwm.org
 Vcs-Git: https://salsa.debian.org/debian/herbstluftwm.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export BUILD_DATE = $(shell date -u -d@$(SOURCE_DATE_EPOCH) +"%Y-%m-%d")
PYTEST_VERSION = $(shell python3 -c 'import sys ; print("py" + "".join([str(i) for i in sys.version_info[:2]]))')

%:
	dh $@ --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install --buildsystem=cmake
	rm -f $(CURDIR)/debian/herbstluftwm/usr/share/doc/herbstluftwm/INSTALL

#override_dh_auto_test:
#	(cd obj-* ; tox -c .. -e py3)


override_dh_installwm:
	dh_installwm --priority=20 herbstluftwm

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## herbstluftwm 0.8.2

=== Makefile ===
## Wrapper around cmake

VERSION = $(shell cat VERSION)

TARFILE = herbstluftwm-$(VERSION).tar

.PHONY: all all-nodoc doc tar

BUILDDIR = build

all: $(BUILDDIR)
	cd $(BUILDDIR) && $(MAKE)
	@echo The compilation result can be found in $(BUILDDIR)/

$(BUILDDIR):
	mkdir -p $@
	cd $@ && cmake ..

clean:
	rm -r build/

doc: $(BUILDDIR)
	cd $(BUILDDIR)/doc && $(MAKE)

tar: doc
	git archive --prefix=herbstluftwm-$(VERSION)/ -o $(TARFILE) HEAD
	tar --transform="flags=r;s,$(BUILDDIR),herbstluftwm-$(VERSION),"  --owner=0 --group=0 \
		-uvf $(TARFILE) build/doc/*.html build/doc/*.[1-9]
	gzip $(TARFILE)
	gpg --detach-sign $(TARFILE).gz

=== ipc-client/CMakeLists.txt ===
## The 'herbstclient' executable ##

add_executable(herbstclient main.c)
install(TARGETS herbstclient DESTINATION ${BINDIR})

# additional sources
target_sources(herbstclient PRIVATE
    client-utils.c	client-utils.h
    ipc-client.c	ipc-client.h
    )

# we require C99, X/Open 6 for POSIC 2004
set_target_properties(herbstclient PROPERTIES
    C_STANDARD 99
    C_STANDARD_REQUIRED ON
    COMPILE_DEFINITIONS _XOPEN_SOURCE=600)

# dependencies X11
target_include_directories(herbstclient SYSTEM PUBLIC
    ${X11_X11_INCLUDE_PATH})
target_link_libraries(herbstclient PUBLIC
    ${X11_X11_LIB})

# communicate version string
export_version(main.c)

# vim: et:ts=4:sw=4

=== www/Makefile ===
--- 
+++ 
@@ -1,12 +1,9 @@
-
-include ../version.mk
-include ../config.mk
-include ../colors.mk
 
 .PHONY: all clean install
 
 TARGET = herbstluftwm.org:www/
 
+ASCIIDOC = asciidoc
 ASCIIDOCFLAGS = -s
 TXT = $(wildcard *.txt)
 INSTALLFILES = $(TXT:.txt=.html) \

=== debian/changelog ===
herbstluftwm (0.8.2-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Christoph Egger <christoph@debian.org>  Tue, 19 May 2020 14:57:28 +0200

herbstluftwm (0.8.2-1) unstable; urgency=medium

  * New upstream release

 -- Christoph Egger <christoph@debian.org>  Tue, 05 May 2020 15:20:13 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: herbstluftwm
 Section: x11
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Christoph Egger <christoph@debian.org>
+Maintainer: Christoph Egger <christoph@debian.org>
 Build-Depends:
  asciidoc,
  cmake,

=== debian/rules ===
--- 
+++ 
@@ -17,6 +17,3 @@
 
 override_dh_installwm:
 	dh_installwm --priority=20 herbstluftwm
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

## herbstluftwm 0.8.3

=== Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 	cd $@ && cmake ..
 
 clean:
-	rm -r build/
+	rm -r $(BUILDDIR)/
 
 doc: $(BUILDDIR)
 	cd $(BUILDDIR)/doc && $(MAKE)
@@ -25,6 +25,6 @@
 tar: doc
 	git archive --prefix=herbstluftwm-$(VERSION)/ -o $(TARFILE) HEAD
 	tar --transform="flags=r;s,$(BUILDDIR),herbstluftwm-$(VERSION),"  --owner=0 --group=0 \
-		-uvf $(TARFILE) build/doc/*.html build/doc/*.[1-9]
+		-uvf $(TARFILE) $(BUILDDIR)/doc/*.html $(BUILDDIR)/doc/*.[1-9]
 	gzip $(TARFILE)
 	gpg --detach-sign $(TARFILE).gz

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,7 @@
         # asciidoc doesn't support destination directory for manpages
         COMMAND ${CMAKE_COMMAND} -E copy ${src_orig} ${src}
         COMMAND ${ASCIIDOC_A2X}
+                --no-xmllint
                 -f manpage
                 -a \"herbstluftwmversion=herbstluftwm ${VERSION}\"
                 -a \"date=`date +%Y-%m-%d`\"

=== debian/changelog ===
herbstluftwm (0.8.3-2.0antix1) unstable; urgency=medium

  * antiX buster build 

 -- anticapitalista <antix@operamail.com>  Tue, 23 Jun 2020 13:00:36 +0300

herbstluftwm (0.8.3-2) unstable; urgency=medium

  * Import upstream fix for XProperty type

 -- Christoph Egger <christoph@debian.org>  Mon, 22 Jun 2020 13:34:46 +0200

herbstluftwm (0.8.3-1) unstable; urgency=medium

  * New upstream release
  * Enable Tests

 -- Christoph Egger <christoph@debian.org>  Thu, 18 Jun 2020 16:52:37 +0200

=== debian/rules ===
--- 
+++ 
@@ -11,8 +11,8 @@
 	dh_auto_install --buildsystem=cmake
 	rm -f $(CURDIR)/debian/herbstluftwm/usr/share/doc/herbstluftwm/INSTALL
 
-#override_dh_auto_test:
-#	(cd obj-* ; tox -c .. -e py3)
+override_dh_auto_test:
+	(cd obj-* ; python3 -m pytest ../tests)
 
 
 override_dh_installwm:

## herbstluftwm 0.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -36,7 +36,7 @@
     CACHE PATH "Install path for zsh completions file")
 set(FISHCOMPLETIONDIR ${DATADIR}/fish/vendor_completions.d
     CACHE PATH "Install path for fish completions file")
-set(BASHCOMPLETIONDIR ${CMAKE_INSTALL_SYSCONF_PREFIX}/bash_completion.d
+set(BASHCOMPLETIONDIR ${DATADIR}/bash-completion/completions
     CACHE PATH "Install path for bash completions file")
 
 ## do the actual work
@@ -46,7 +46,7 @@
 add_subdirectory(share)
 
 ## install everything that was not installed from subdirectories
-install(FILES BUGS NEWS INSTALL DESTINATION ${DOCDIR})
+install(FILES BUGS NEWS DESTINATION ${DOCDIR})
 install(FILES LICENSE DESTINATION ${LICENSEDIR})
 install(DIRECTORY scripts/ DESTINATION ${DOCDIR}/examples USE_SOURCE_PERMISSIONS)

=== Makefile ===
--- 
+++ 
@@ -25,6 +25,6 @@
 tar: doc
 	git archive --prefix=herbstluftwm-$(VERSION)/ -o $(TARFILE) HEAD
 	tar --transform="flags=r;s,$(BUILDDIR),herbstluftwm-$(VERSION),"  --owner=0 --group=0 \
-		-uvf $(TARFILE) $(BUILDDIR)/doc/*.html $(BUILDDIR)/doc/*.[1-9]
+		-uvf $(TARFILE) $(BUILDDIR)/doc/*.{html,json} $(BUILDDIR)/doc/*.[1-9]
 	gzip $(TARFILE)
 	gpg --detach-sign $(TARFILE).gz

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,22 @@
 option(WITH_DOCUMENTATION "Build with documentation" ON)
+
+function(gen_json_doc destfile)
+    set(dst "${CMAKE_CURRENT_BINARY_DIR}/${destfile}.json")
+    AUX_SOURCE_DIRECTORY("${CMAKE_CURRENT_SOURCE_DIR}/../src" CPPSRC)
+    add_custom_target("doc_json" ALL DEPENDS ${dst})
+    add_custom_command(
+        OUTPUT ${dst}
+        COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/gendoc.py" --sourcedir "${CMAKE_CURRENT_SOURCE_DIR}/../src" --json > ${dst}
+        DEPENDS ${CPPSRC} "${CMAKE_CURRENT_SOURCE_DIR}/gendoc.py"
+        )
+    install(FILES ${dst} DESTINATION ${DOCDIR})
+endfunction()
 
 function(gen_manpage sourcefile man_nr)
     set(src_orig "${CMAKE_CURRENT_SOURCE_DIR}/${sourcefile}.txt")
     set(src "${CMAKE_CURRENT_BINARY_DIR}/${sourcefile}.txt")
     set(dst "${CMAKE_CURRENT_BINARY_DIR}/${sourcefile}.${man_nr}")
+    STRING(TIMESTAMP BUILD_DATE "%Y-%m-%d" UTC)
 
     add_custom_target("doc_man_${sourcefile}" ALL DEPENDS ${dst})
     add_custom_command(
@@ -15,7 +28,7 @@
                 --no-xmllint
                 -f manpage
                 -a \"herbstluftwmversion=herbstluftwm ${VERSION}\"
-                -a \"date=`date +%Y-%m-%d`\"
+                -a \"date=${BUILD_DATE}\"
                 ${src}
         DEPENDS ${src_orig}
         )
@@ -36,6 +49,8 @@
     install(FILES ${dst} DESTINATION ${DOCDIR})
 endfunction()
 
+gen_json_doc(hlwm-doc)
+
 if (WITH_DOCUMENTATION)
     find_program(ASCIIDOC_A2X NAMES a2x DOC "Path to AsciiDoc a2x command")
     find_program(ASCIIDOC NAMES asciidoc DOC "Path to AsciiDoc command")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 # additional sources – core/architectural stuff
 target_sources(herbstluftwm PRIVATE
     arglist.cpp arglist.h
+    argparse.cpp argparse.h
     attribute.cpp attribute.h attribute_.h
     byname.cpp byname.h
     child.h
@@ -18,6 +19,8 @@
     desktopwindow.h desktopwindow.cpp
     entity.cpp entity.h
     ewmh.cpp ewmh.h
+    finite.h
+    fixprecdec.cpp fixprecdec.h
     floating.cpp floating.h
     framedata.h framedata.cpp
     framedecoration.cpp framedecoration.h

=== www/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 .PHONY: all clean install
 
-TARGET = herbstluftwm.org:www/
+TARGET = herbstluftwm.org:html/
 
 ASCIIDOC = asciidoc
 ASCIIDOCFLAGS = -s
@@ -10,7 +10,12 @@
 	herbstluftwm.html \
 	herbstclient.html \
 	herbstluftwm.svg \
-	main.css
+	favicon.ico \
+	main.css \
+	.htaccess \
+	$(LINKS)
+
+LINKS = NEWS MIGRATION
 
 all: $(INSTALLFILES)
 
@@ -39,8 +44,16 @@
 
 faq.html: faq-toc.html
 
+favicon.ico: ../share/herbstluftwm.svg
+	convert -density 256x256 -background transparent $< \
+        -define icon:auto-resize -colors 256 $@
+
+# some symbolic links to make links in these asciidoc files work in www, too
+$(LINKS):
+	ln -sf $(shell echo $@ | tr A-Z a-z).html $@
+
 clean:
-	rm -f *.html *-content.html
+	rm -f *.html *-content.html $(LINKS)
 
 install: all
-	rsync -v $(INSTALLFILES) $(TARGET)
+	rsync -v -l $(INSTALLFILES) $(TARGET)

=== debian/changelog ===
herbstluftwm (0.9.0-1) unstable; urgency=medium

  * New upstream release

 -- Christoph Egger <christoph@debian.org>  Fri, 20 Nov 2020 15:16:39 +0100

herbstluftwm (0.8.3-3) unstable; urgency=medium

  * Upstream fix for FP imprecision (PR 942)
  * Some more room for test timeouts

 -- Christoph Egger <christoph@debian.org>  Sat, 04 Jul 2020 14:19:42 +0200

=== debian/control ===
--- 
+++ 
@@ -12,16 +12,18 @@
  libxinerama-dev,
  libxml2-utils,
  libxrandr-dev,
-# python3,
-# python3-ewmh,
-# python3-pytest,
-# python3-pytest-xdist,
-# python3-pytest-xvfb,
-# python3-xlib,
-# tox,
+ python3,
+ python3-ewmh,
+ python3-pytest,
+ python3-pytest-xdist,
+ python3-pytest-xvfb,
+ python3-xlib,
+ x11-utils,
+ x11-xserver-utils,
+ xdotool,
+ xserver-xephyr,
  xsltproc,
-# x11-utils,
-# xterm
+ xterm
 Standards-Version: 4.1.4
 Homepage: https://herbstluftwm.org
 Vcs-Git: https://salsa.debian.org/debian/herbstluftwm.git

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,8 @@
 	rm -f $(CURDIR)/debian/herbstluftwm/usr/share/doc/herbstluftwm/INSTALL
 
 override_dh_auto_test:
-	(cd obj-* ; python3 -m pytest ../tests)
+#	(cd obj-* ; python3 -m pytest --log-cli-level=DEBUG -x ../tests/test_layout.py::test_dump_frame_index)
+	(cd obj-* ; python3 -m pytest -x ../tests)
 
 
 override_dh_installwm:

## herbstluftwm 0.9.1

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -3,13 +3,13 @@
 function(gen_json_doc destfile)
     set(dst "${CMAKE_CURRENT_BINARY_DIR}/${destfile}.json")
     AUX_SOURCE_DIRECTORY("${CMAKE_CURRENT_SOURCE_DIR}/../src" CPPSRC)
-    add_custom_target("doc_json" ALL DEPENDS ${dst})
+    add_custom_target("doc_json" DEPENDS ${dst})
     add_custom_command(
         OUTPUT ${dst}
         COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/gendoc.py" --sourcedir "${CMAKE_CURRENT_SOURCE_DIR}/../src" --json > ${dst}
         DEPENDS ${CPPSRC} "${CMAKE_CURRENT_SOURCE_DIR}/gendoc.py"
         )
-    install(FILES ${dst} DESTINATION ${DOCDIR})
+    install(FILES ${dst} DESTINATION ${DOCDIR} OPTIONAL)
 endfunction()
 
 function(gen_manpage sourcefile man_nr)
@@ -49,8 +49,6 @@
     install(FILES ${dst} DESTINATION ${DOCDIR})
 endfunction()
 
-gen_json_doc(hlwm-doc)
-
 if (WITH_DOCUMENTATION)
     find_program(ASCIIDOC_A2X NAMES a2x DOC "Path to AsciiDoc a2x command")
     find_program(ASCIIDOC NAMES asciidoc DOC "Path to AsciiDoc command")
@@ -62,6 +60,13 @@
     gen_html(herbstclient)
     gen_html(herbstluftwm)
     gen_html(herbstluftwm-tutorial)
+
+    # mark the doc_json target as mandatory
+    add_custom_target("doc_json_mandatory" ALL DEPENDS "doc_json")
 endif()
 
+# always create a doc_json target, but only make it mandatory
+# if WITH_DOCUMENTATION is set
+gen_json_doc(hlwm-doc)
+
 # vim: et:ts=4:sw=4

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -37,6 +37,7 @@
     keymanager.cpp keymanager.h
     layout.cpp layout.h
     link.h
+    metacommands.cpp metacommands.h
     monitor.cpp monitor.h
     monitordetection.cpp monitordetection.h
     monitormanager.cpp monitormanager.h
@@ -50,7 +51,6 @@
     panelmanager.h panelmanager.cpp
     rectangle.cpp rectangle.h
     regexstr.cpp regexstr.h
-    rootcommands.cpp rootcommands.h
     root.cpp root.h
     rulemanager.cpp rulemanager.h
     rules.cpp rules.h

=== debian/changelog ===
herbstluftwm (0.9.1-1.0antix1) unstable; urgency=medium

  * latest upstream
  * antiX build 

 -- anticapitalista <antix@operamail.com>  Mon, 25 Jan 2021 01:13:39 +0200

herbstluftwm (0.9.0-1.0antix1) unstable; urgency=medium

  * latest upstream
  * antiX build

 -- anticapitalista <antix@operamail.com>  Thu, 12 Nov 2020 01:17:50 +0200

herbstluftwm (0.8.3-3.0antix1) unstable; urgency=medium

  * antiX buster build 

 -- anticapitalista <antix@operamail.com>  Mon, 06 Jul 2020 22:26:58 +0300

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 override_dh_auto_test:
 #	(cd obj-* ; python3 -m pytest --log-cli-level=DEBUG -x ../tests/test_layout.py::test_dump_frame_index)
-	(cd obj-* ; python3 -m pytest -x ../tests)
+#	(cd obj-* ; python3 -m pytest -x ../tests)
 
 
 override_dh_installwm:
